import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["React", "ReactDOM"];
import React, { useEffect, useRef } from 'react';
import ReactDOM from 'react-dom';
import { useState } from 'react';
import { babelTransform } from './transform';
export function useCodePreview(props) {
  var [demoDom, setDemoDom] = useState();
  var playerId = useRef("" + parseInt(String(Math.random() * 1e9), 10).toString(36));
  var [fullScreen, setFullScreen] = useState(false);
  var [errorMessage, setErrorMessage] = useState('');
  var [showEdit, setShowEdit] = useState(false);
  var [width, setWidth] = useState(1);
  var [copied, setCopied] = useState(false);
  var [code, setCode] = useState(props.code || '');

  var executeCode = str => {
    var _ref = props.dependencies || {},
        {
      React: _React,
      ReactDOM: _ReactDOM
    } = _ref,
        otherDeps = _objectWithoutPropertiesLoose(_ref, _excluded);

    try {
      var deps = _extends({
        React: _React || React,
        ReactDOM: _ReactDOM || ReactDOM
      }, otherDeps); // const args = ['context', 'React', 'ReactDOM', 'Component'];


      var args = []; // const argv = [this, React, ReactDOM, Component];

      var argv = [];

      for (var key in deps) {
        args.push(key);
        argv.push(deps[key]);
      }

      str = str.replace('_mount_', "document.getElementById('" + playerId.current + "')");
      var input = "" + str;
      var {
        code: _code
      } = babelTransform(input);
      args.push(_code || ''); // console.log('code:', argv)
      // eslint-disable-next-line no-new-func

      new Function(...args).apply(null, argv);
      setErrorMessage('');
    } catch (err) {
      var message = '';

      if (err && err.message) {
        message = err.message;
      } else {
        message = JSON.stringify(err);
      }

      setErrorMessage(message);
    }
  }; // eslint-disable-next-line react-hooks/exhaustive-deps


  useEffect(() => executeCode(code), [code, props.noPreview, demoDom]);
  return {
    playerId,
    demoDom,
    setDemoDom,
    fullScreen,
    setFullScreen,
    errorMessage,
    setErrorMessage,
    width,
    setWidth,
    showEdit,
    setShowEdit,
    copied,
    setCopied,
    code,
    setCode,
    executeCode
  };
}
//# sourceMappingURL=useCodePreview.js.map